uses TGGlob,
     Graph, Crt,
     TGGraph, TGSprite, TGSprMo, TGPCX, TG3D;

const
  GD: Integer = 3;
  GM: Integer = 1;

procedure NortonText;
begin
  SetColor (14);
  SetTextStyle (0, 1, 1);
  OutTextXY (130, 12, '  ନ஢      ');
  OutTextXY (150, 12, '3- ࠦ             ');
  OutTextXY (170, 12, ' ࠡ⪮ ᢥ饭.       ');
  OutTextXY (190, 12, ' 誨   ࠩ⮬.');
end;

procedure Norton;
var
  N: Integer;
  Ch: Char;
begin
  DisplayPCX ('NORTON1.PCX', ActPg);
  NortonText;
  ListPg;
  LoadSprite (SprMo, 'PRILIP.SPR');
  SprMoInit;
  TakeMem;
  FormIniPoi;
  FormPl;
  InitSort;
  Angle := 0;
  SetColor (0);
  Ch := #0; N:=0;
  repeat
  Inc (N);
    SetFillStyle (1, 0);
    FormPoi (Angle, -100, 0, -60);
    FormScPoi;
    CalcDist;
    SortPlan;
    SetColors;
    SprMoHide;
    ListPg;
    SetActivePage (VisPg);
    DrawPlan;
    SetActivePage (ActPg);
    SprMoShow;
    Angle:= Angle + 25; if Angle > 360 then Angle := Angle - 360;
  until KeyPressed or (N > 3);
  if KeyPressed then Ch := ReadKey;
  if Ch = #27 then ErrMsg ('By!');
  SetActivePage (ActPg);
  PutMem;
  SprMoClose;
end;

const
  Card: array [1..18, 1..2] of Integer = (
  (0, 8),
  (5, 15), (14, 17), (23, 15), (29, 9),
  (30, 0), (24, -8), (13, -15), (6, -20),
  (0, -26),
  (-6, -20), (-13, -15), (-24, -8), (-30, 0),
  (-29, 9), (-23, 15), (-14, 17), (-5, 15)
  );
  Cent: array [1..2] of Integer =  (320, 260);
  First: array [0..1] of Boolean = (TRUE, TRUE);

var
  Data: array [0..1] of record
    MinX, MaxX, MinY, MaxY: Integer;
    BkGrSize: LongInt;
    Buff: Pointer;
  end;

procedure Cardis (D: Real);
var
  i, j: Integer;
  C: array [1..18, 1..2] of Integer;
begin
  with Data[ActPg] do begin
    for i:=1 to 18 do
      for j:=1 to 2 do C[i, j] := Round (Cent[j] - Card[i, j] * D);
    if not First[ActPg] then begin
      FastPutImage (MinX, MinY, Buff);
      FreeMem (Buff, BkGrSize);
    end;
    MinX := C[1, 1]; MaxX := C[1, 1];
    MinY := C[1, 2]; MaxY := C[1, 2];
    for i:=2 to 18 do begin
      if C[i, 1] < MinX then MinX := C[i, 1];
      if C[i, 1] > MaxX then MaxX := C[i, 1];
      if C[i, 2] < MinY then MinY := C[i, 2];
      if C[i, 2] > MaxY then MaxY := C[i, 2];
    end;
    Dec (MinX); Dec(MinY); Inc (MaxX); Inc (MaxY);
    BkGrSize := FastImageSize (MinX, MinY, MaxX, MaxY);
    GetMem (Buff, BkGrSize);
    FastGetImage (MinX, MinY, MaxX, MaxY, Buff);
    First[ActPg] := FALSE;
    FillPoly (18, C);
  end;
end;

procedure GirlText;
begin
  SetFillStyle (1, 8);
  Bar (0, 300, 639, 349);
  OutTextXY (120, 310, '  뢮  ࠭ 䠩 PCX ଠ.');
  OutTextXY (120, 320, ' ⮬ ন ⠭⭠ 䨪.');
end;

procedure Girl;
var
  i, N: Integer;
  Ch: Char;
begin
  DisplayPCX ('NEW.PCX', ActPg);
  GirlText;
  ListPg;
  SetLineStyle (0, 0, 3);
  SetColor (15);
  SetFillStyle (1, 4);
  i := 0; N := 0;
  repeat
  Inc (N);
    Sync;
    Cardis (i*0.2);
    SwitchPg;
    Inc (i); if i=15 then i:=0;
  until KeyPressed or (N>500);
  if KeyPressed then Ch := ReadKey;
  if Ch = #27 then ErrMsg ('By!');
  SetLineStyle (0, 0, 0);
  SetColor (15);
  SetFillStyle (1, 0);
  Bar (0, 0, 639, 349);
  ListPg;
end;

var
  Pr: TSprDta;

type
  TObj = object
    X, Y, dX, dY: Integer;
    Col: Byte;
    constructor Init (iX, iY, idX, idY: Integer);
    destructor Done;
    procedure Move; virtual;
    procedure Draw; virtual;
  end;

  TObj1 = object (TObj)
    procedure Draw; virtual;
  end;

  TObj2 = object (TObj)
    procedure Draw; virtual;
  end;

  TObj3 = object (TObj)
    procedure Draw; virtual;
  end;

constructor TObj.Init (iX, iY, idX, idY: Integer);
begin
  X := iX;
  Y := iY;
  dX := idX;
  dY := idY;
  Col := 9+Random (7);
end;

destructor TObj.Done;
begin
end;

procedure TObj.Move;
begin
  X := X + dX;
  if (X < 10) or (X > 630) then dX := -dX;
  Y := Y + dY;
  if (Y < 10) or (Y > 290) then dY := -dY;
end;

procedure TObj.Draw;
begin
end;

procedure TObj1.Draw;
begin
  SetColor (Col);
  Ellipse (X, Y, 0, 360, 10, 20);
end;

procedure TObj2.Draw;
begin
  SetColor (Col);
  SetFillStyle (1, Col);
  FillEllipse (X, Y, 20, 10);
end;

procedure TObj3.Draw;
begin
  Inc (Col);
  with Pr do begin
    if Col > NOfPhase then Col := 1;
    PutVPSprite (X, Y, SprPtr [Col]);
  end;
end;

function Rand: Integer;
begin
  Rand := Random (10) - 5;
end;

var
  Ob1: array [1..8] of TObj1;
  Ob2: array [1..8] of TObj2;
  Ob3: array [1..8] of TObj3;

procedure PrilipText;
begin
  SetColor (15);
  SetFillStyle (1, 1);
  SetTextStyle (0, 0, 1);
  Bar (0,300, 639, 349);
  OutTextXY (130, 310, '  ࠡ  ࠩ⠬ 筮 ⠪,');
  OutTextXY (130, 320, '   ⠫묨 ꥪ⠬ ⠭⭮ 䨪.');
  SetColor (14);
  OutTextXY (130, 330, '        祭   ᯮ짮!        ');
end;

procedure Prilip;
var
  i, N: Integer;
  Ch: Char;
begin
  LoadSprite (Pr, 'PRILIP.SPR');
  for i:=1 to 8 do begin
    with Ob1[i] do Init (320, 175, Rand, Rand);
    with Ob2[i] do Init (320, 175, Rand, Rand);
    with Ob3[i] do Init (320, 175, Rand, Rand);
  end;
  PrilipText;
  ListPg;
  SetViewPort (0, 0, 639, 299, TRUE);
  SetSpriteViewPort (0, 0, 639, 299);
  N := 0;
  repeat
  Inc (N);
    SetFillStyle (1, 0);
    Bar (0, 0, 639, 299);
    for i:=1 to 8 do begin
      with Ob1[i] do Move;
      with Ob2[i] do Move;
      with Ob3[i] do Move;
    end;
    Sync;
    for i:=1 to 8 do begin
      with Ob1[i] do Draw;
      with Ob2[i] do Draw;
      with Ob3[i] do Draw;
    end;
    SwitchPg;
  until KeyPressed or (N>200);
  if KeyPressed then Ch := ReadKey;
  if Ch = #27 then ErrMsg ('By!');
  SetViewPort (0, 0, 639, 349, TRUE);
  SetSpriteViewPort (0, 0, 639, 349);
  FreeSprite (Pr);
end;

begin
  InitGraph (GD, GM, '');
  Randomize;
  SetActivePage (ActPg);
  Girl;
  Norton;
  Prilip;
  CloseGraph;
end.